<?php

// Data functions (insert, update, delete, form) for table transactions

// This script and data application were generated by AppGini 5.62
// Download AppGini for free from https://bigprof.com/appgini/download/

function transactions_insert(){
	global $Translation;

	// mm: can member insert record?
	$arrPerm=getTablePermissions('transactions');
	if(!$arrPerm[1]){
		return false;
	}

	$data['transaction_date'] = intval($_REQUEST['transaction_dateYear']) . '-' . intval($_REQUEST['transaction_dateMonth']) . '-' . intval($_REQUEST['transaction_dateDay']);
	$data['transaction_date'] = parseMySQLDate($data['transaction_date'], '1');
	$data['item'] = makeSafe($_REQUEST['item']);
		if($data['item'] == empty_lookup_value){ $data['item'] = ''; }
	$data['batch'] = makeSafe($_REQUEST['batch']);
		if($data['batch'] == empty_lookup_value){ $data['batch'] = ''; }
	$data['section'] = makeSafe($_REQUEST['section']);
		if($data['section'] == empty_lookup_value){ $data['section'] = ''; }
	$data['transaction_type'] = makeSafe($_REQUEST['transaction_type']);
		if($data['transaction_type'] == empty_lookup_value){ $data['transaction_type'] = ''; }
	$data['quantity'] = makeSafe($_REQUEST['quantity']);
		if($data['quantity'] == empty_lookup_value){ $data['quantity'] = ''; }
	if($data['transaction_type']== ''){
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">" . $Translation['error:'] . " 'Transaction type': " . $Translation['field not null'] . '<br><br>';
		echo '<a href="" onclick="history.go(-1); return false;">'.$Translation['< back'].'</a></div>';
		exit;
	}
	if($data['quantity'] == '') $data['quantity'] = "1.00";

	// hook: transactions_before_insert
	if(function_exists('transactions_before_insert')){
		$args=array();
		if(!transactions_before_insert($data, getMemberInfo(), $args)){ return false; }
	}

	$o = array('silentErrors' => true);
	sql('insert into `transactions` set       `transaction_date`=' . (($data['transaction_date'] !== '' && $data['transaction_date'] !== NULL) ? "'{$data['transaction_date']}'" : 'NULL') . ', `item`=' . (($data['item'] !== '' && $data['item'] !== NULL) ? "'{$data['item']}'" : 'NULL') . ', `batch`=' . (($data['batch'] !== '' && $data['batch'] !== NULL) ? "'{$data['batch']}'" : 'NULL') . ', `section`=' . (($data['section'] !== '' && $data['section'] !== NULL) ? "'{$data['section']}'" : 'NULL') . ', `transaction_type`=' . (($data['transaction_type'] !== '' && $data['transaction_type'] !== NULL) ? "'{$data['transaction_type']}'" : 'NULL') . ', `quantity`=' . (($data['quantity'] !== '' && $data['quantity'] !== NULL) ? "'{$data['quantity']}'" : 'NULL'), $o);
	if($o['error']!=''){
		echo $o['error'];
		echo "<a href=\"transactions_view.php?addNew_x=1\">{$Translation['< back']}</a>";
		exit;
	}

	$recID = db_insert_id(db_link());

	// hook: transactions_after_insert
	if(function_exists('transactions_after_insert')){
		$res = sql("select * from `transactions` where `id`='" . makeSafe($recID, false) . "' limit 1", $eo);
		if($row = db_fetch_assoc($res)){
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = makeSafe($recID, false);
		$args=array();
		if(!transactions_after_insert($data, getMemberInfo(), $args)){ return $recID; }
	}

	// mm: save ownership data
	sql("insert ignore into membership_userrecords set tableName='transactions', pkValue='" . makeSafe($recID, false) . "', memberID='" . makeSafe(getLoggedMemberID(), false) . "', dateAdded='" . time() . "', dateUpdated='" . time() . "', groupID='" . getLoggedGroupID() . "'", $eo);

	return $recID;
}

function transactions_delete($selected_id, $AllowDeleteOfParents=false, $skipChecks=false){
	// insure referential integrity ...
	global $Translation;
	$selected_id=makeSafe($selected_id);

	// mm: can member delete record?
	$arrPerm=getTablePermissions('transactions');
	$ownerGroupID=sqlValue("select groupID from membership_userrecords where tableName='transactions' and pkValue='$selected_id'");
	$ownerMemberID=sqlValue("select lcase(memberID) from membership_userrecords where tableName='transactions' and pkValue='$selected_id'");
	if(($arrPerm[4]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[4]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[4]==3){ // allow delete?
		// delete allowed, so continue ...
	}else{
		return $Translation['You don\'t have enough permissions to delete this record'];
	}

	// hook: transactions_before_delete
	if(function_exists('transactions_before_delete')){
		$args=array();
		if(!transactions_before_delete($selected_id, $skipChecks, getMemberInfo(), $args))
			return $Translation['Couldn\'t delete this record'];
	}

	sql("delete from `transactions` where `id`='$selected_id'", $eo);

	// hook: transactions_after_delete
	if(function_exists('transactions_after_delete')){
		$args=array();
		transactions_after_delete($selected_id, getMemberInfo(), $args);
	}

	// mm: delete ownership data
	sql("delete from membership_userrecords where tableName='transactions' and pkValue='$selected_id'", $eo);
}

function transactions_update($selected_id){
	global $Translation;

	// mm: can member edit record?
	$arrPerm=getTablePermissions('transactions');
	$ownerGroupID=sqlValue("select groupID from membership_userrecords where tableName='transactions' and pkValue='".makeSafe($selected_id)."'");
	$ownerMemberID=sqlValue("select lcase(memberID) from membership_userrecords where tableName='transactions' and pkValue='".makeSafe($selected_id)."'");
	if(($arrPerm[3]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[3]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[3]==3){ // allow update?
		// update allowed, so continue ...
	}else{
		return false;
	}

	$data['transaction_date'] = intval($_REQUEST['transaction_dateYear']) . '-' . intval($_REQUEST['transaction_dateMonth']) . '-' . intval($_REQUEST['transaction_dateDay']);
	$data['transaction_date'] = parseMySQLDate($data['transaction_date'], '1');
	$data['item'] = makeSafe($_REQUEST['item']);
		if($data['item'] == empty_lookup_value){ $data['item'] = ''; }
	$data['batch'] = makeSafe($_REQUEST['batch']);
		if($data['batch'] == empty_lookup_value){ $data['batch'] = ''; }
	$data['section'] = makeSafe($_REQUEST['section']);
		if($data['section'] == empty_lookup_value){ $data['section'] = ''; }
	$data['transaction_type'] = makeSafe($_REQUEST['transaction_type']);
		if($data['transaction_type'] == empty_lookup_value){ $data['transaction_type'] = ''; }
	if($data['transaction_type']==''){
		echo StyleSheet() . "\n\n<div class=\"alert alert-danger\">{$Translation['error:']} 'Transaction type': {$Translation['field not null']}<br><br>";
		echo '<a href="" onclick="history.go(-1); return false;">'.$Translation['< back'].'</a></div>';
		exit;
	}
	$data['quantity'] = makeSafe($_REQUEST['quantity']);
		if($data['quantity'] == empty_lookup_value){ $data['quantity'] = ''; }
	$data['selectedID']=makeSafe($selected_id);

	// hook: transactions_before_update
	if(function_exists('transactions_before_update')){
		$args=array();
		if(!transactions_before_update($data, getMemberInfo(), $args)){ return false; }
	}

	$o=array('silentErrors' => true);
	sql('update `transactions` set       `transaction_date`=' . (($data['transaction_date'] !== '' && $data['transaction_date'] !== NULL) ? "'{$data['transaction_date']}'" : 'NULL') . ', `item`=' . (($data['item'] !== '' && $data['item'] !== NULL) ? "'{$data['item']}'" : 'NULL') . ', `batch`=' . (($data['batch'] !== '' && $data['batch'] !== NULL) ? "'{$data['batch']}'" : 'NULL') . ', `section`=' . (($data['section'] !== '' && $data['section'] !== NULL) ? "'{$data['section']}'" : 'NULL') . ', `transaction_type`=' . (($data['transaction_type'] !== '' && $data['transaction_type'] !== NULL) ? "'{$data['transaction_type']}'" : 'NULL') . ', `quantity`=' . (($data['quantity'] !== '' && $data['quantity'] !== NULL) ? "'{$data['quantity']}'" : 'NULL') . " where `id`='".makeSafe($selected_id)."'", $o);
	if($o['error']!=''){
		echo $o['error'];
		echo '<a href="transactions_view.php?SelectedID='.urlencode($selected_id)."\">{$Translation['< back']}</a>";
		exit;
	}


	// hook: transactions_after_update
	if(function_exists('transactions_after_update')){
		$res = sql("SELECT * FROM `transactions` WHERE `id`='{$data['selectedID']}' LIMIT 1", $eo);
		if($row = db_fetch_assoc($res)){
			$data = array_map('makeSafe', $row);
		}
		$data['selectedID'] = $data['id'];
		$args = array();
		if(!transactions_after_update($data, getMemberInfo(), $args)){ return; }
	}

	// mm: update ownership data
	sql("update membership_userrecords set dateUpdated='".time()."' where tableName='transactions' and pkValue='".makeSafe($selected_id)."'", $eo);

}

function transactions_form($selected_id = '', $AllowUpdate = 1, $AllowInsert = 1, $AllowDelete = 1, $ShowCancel = 0, $TemplateDV = '', $TemplateDVP = ''){
	// function to return an editable form for a table records
	// and fill it with data of record whose ID is $selected_id. If $selected_id
	// is empty, an empty form is shown, with only an 'Add New'
	// button displayed.

	global $Translation;

	// mm: get table permissions
	$arrPerm=getTablePermissions('transactions');
	if(!$arrPerm[1] && $selected_id==''){ return ''; }
	$AllowInsert = ($arrPerm[1] ? true : false);
	// print preview?
	$dvprint = false;
	if($selected_id && $_REQUEST['dvprint_x'] != ''){
		$dvprint = true;
	}

	$filterer_item = thisOr(undo_magic_quotes($_REQUEST['filterer_item']), '');
	$filterer_batch = thisOr(undo_magic_quotes($_REQUEST['filterer_batch']), '');
	$filterer_section = thisOr(undo_magic_quotes($_REQUEST['filterer_section']), '');

	// populate filterers, starting from children to grand-parents
	if($filterer_batch && !$filterer_item) $filterer_item = sqlValue("select item from batches where id='" . makeSafe($filterer_batch) . "'");

	// unique random identifier
	$rnd1 = ($dvprint ? rand(1000000, 9999999) : '');
	// combobox: transaction_date
	$combo_transaction_date = new DateCombo;
	$combo_transaction_date->DateFormat = "dmy";
	$combo_transaction_date->MinYear = 1900;
	$combo_transaction_date->MaxYear = 2100;
	$combo_transaction_date->DefaultDate = parseMySQLDate('1', '1');
	$combo_transaction_date->MonthNames = $Translation['month names'];
	$combo_transaction_date->NamePrefix = 'transaction_date';
	// combobox: item
	$combo_item = new DataCombo;
	// combobox: batch, filterable by: item
	$combo_batch = new DataCombo;
	// combobox: section
	$combo_section = new DataCombo;
	// combobox: transaction_type
	$combo_transaction_type = new Combo;
	$combo_transaction_type->ListType = 2;
	$combo_transaction_type->MultipleSeparator = ', ';
	$combo_transaction_type->ListBoxHeight = 10;
	$combo_transaction_type->RadiosPerLine = 1;
	if(is_file(dirname(__FILE__).'/hooks/transactions.transaction_type.csv')){
		$transaction_type_data = addslashes(implode('', @file(dirname(__FILE__).'/hooks/transactions.transaction_type.csv')));
		$combo_transaction_type->ListItem = explode('||', entitiesToUTF8(convertLegacyOptions($transaction_type_data)));
		$combo_transaction_type->ListData = $combo_transaction_type->ListItem;
	}else{
		$combo_transaction_type->ListItem = explode('||', entitiesToUTF8(convertLegacyOptions("Incoming;;Outgoing;;Expired;;Damaged")));
		$combo_transaction_type->ListData = $combo_transaction_type->ListItem;
	}
	$combo_transaction_type->SelectName = 'transaction_type';
	$combo_transaction_type->AllowNull = false;

	if($selected_id){
		// mm: check member permissions
		if(!$arrPerm[2]){
			return "";
		}
		// mm: who is the owner?
		$ownerGroupID=sqlValue("select groupID from membership_userrecords where tableName='transactions' and pkValue='".makeSafe($selected_id)."'");
		$ownerMemberID=sqlValue("select lcase(memberID) from membership_userrecords where tableName='transactions' and pkValue='".makeSafe($selected_id)."'");
		if($arrPerm[2]==1 && getLoggedMemberID()!=$ownerMemberID){
			return "";
		}
		if($arrPerm[2]==2 && getLoggedGroupID()!=$ownerGroupID){
			return "";
		}

		// can edit?
		if(($arrPerm[3]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[3]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[3]==3){
			$AllowUpdate=1;
		}else{
			$AllowUpdate=0;
		}

		$res = sql("select * from `transactions` where `id`='".makeSafe($selected_id)."'", $eo);
		if(!($row = db_fetch_array($res))){
			return error_message($Translation['No records found'], 'transactions_view.php', false);
		}
		$urow = $row; /* unsanitized data */
		$hc = new CI_Input();
		$row = $hc->xss_clean($row); /* sanitize data */
		$combo_transaction_date->DefaultDate = $row['transaction_date'];
		$combo_item->SelectedData = $row['item'];
		$combo_batch->SelectedData = $row['batch'];
		$combo_section->SelectedData = $row['section'];
		$combo_transaction_type->SelectedData = $row['transaction_type'];
	}else{
		$combo_item->SelectedData = $filterer_item;
		$combo_batch->SelectedData = $filterer_batch;
		$combo_section->SelectedData = $filterer_section;
		$combo_transaction_type->SelectedText = ( $_REQUEST['FilterField'][1]=='6' && $_REQUEST['FilterOperator'][1]=='<=>' ? (get_magic_quotes_gpc() ? stripslashes($_REQUEST['FilterValue'][1]) : $_REQUEST['FilterValue'][1]) : "");
	}
	$combo_item->HTML = '<span id="item-container' . $rnd1 . '"></span><input type="hidden" name="item" id="item' . $rnd1 . '" value="' . html_attr($combo_item->SelectedData) . '">';
	$combo_item->MatchText = '<span id="item-container-readonly' . $rnd1 . '"></span><input type="hidden" name="item" id="item' . $rnd1 . '" value="' . html_attr($combo_item->SelectedData) . '">';
	$combo_batch->HTML = '<span id="batch-container' . $rnd1 . '"></span><input type="hidden" name="batch" id="batch' . $rnd1 . '" value="' . html_attr($combo_batch->SelectedData) . '">';
	$combo_batch->MatchText = '<span id="batch-container-readonly' . $rnd1 . '"></span><input type="hidden" name="batch" id="batch' . $rnd1 . '" value="' . html_attr($combo_batch->SelectedData) . '">';
	$combo_section->HTML = '<span id="section-container' . $rnd1 . '"></span><input type="hidden" name="section" id="section' . $rnd1 . '" value="' . html_attr($combo_section->SelectedData) . '">';
	$combo_section->MatchText = '<span id="section-container-readonly' . $rnd1 . '"></span><input type="hidden" name="section" id="section' . $rnd1 . '" value="' . html_attr($combo_section->SelectedData) . '">';
	$combo_transaction_type->Render();

	ob_start();
	?>

	<script>
		// initial lookup values
		AppGini.current_item__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['item'] : $filterer_item); ?>"};
		AppGini.current_batch__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['batch'] : $filterer_batch); ?>"};
		AppGini.current_section__RAND__ = { text: "", value: "<?php echo addslashes($selected_id ? $urow['section'] : $filterer_section); ?>"};

		jQuery(function() {
			setTimeout(function(){
				if(typeof(item_reload__RAND__) == 'function') item_reload__RAND__();
				<?php echo (!$AllowUpdate || $dvprint ? 'if(typeof(batch_reload__RAND__) == \'function\') batch_reload__RAND__(AppGini.current_item__RAND__.value);' : ''); ?>
				if(typeof(section_reload__RAND__) == 'function') section_reload__RAND__();
			}, 10); /* we need to slightly delay client-side execution of the above code to allow AppGini.ajaxCache to work */
		});
		function item_reload__RAND__(){
		<?php if(($AllowUpdate || $AllowInsert) && !$dvprint){ ?>

			$j("#item-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c){
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { id: AppGini.current_item__RAND__.value, t: 'transactions', f: 'item' },
						success: function(resp){
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="item"]').val(resp.results[0].id);
							$j('[id=item-container-readonly__RAND__]').html('<span id="item-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=items_view_parent]').hide(); }else{ $j('.btn[id=items_view_parent]').show(); }

						if(typeof(batch_reload__RAND__) == 'function') batch_reload__RAND__(AppGini.current_item__RAND__.value);

							if(typeof(item_update_autofills__RAND__) == 'function') item_update_autofills__RAND__();
						}
					});
				},
				width: ($j('fieldset .col-xs-11').width() - select2_max_width_decrement()) + 'px',
				formatNoMatches: function(term){ return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 10,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page){ return { s: term, p: page, t: 'transactions', f: 'item' }; },
					results: function(resp, page){ return resp; }
				},
				escapeMarkup: function(str){ return str; }
			}).on('change', function(e){
				AppGini.current_item__RAND__.value = e.added.id;
				AppGini.current_item__RAND__.text = e.added.text;
				$j('[name="item"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=items_view_parent]').hide(); }else{ $j('.btn[id=items_view_parent]').show(); }

						if(typeof(batch_reload__RAND__) == 'function') batch_reload__RAND__(AppGini.current_item__RAND__.value);

				if(typeof(item_update_autofills__RAND__) == 'function') item_update_autofills__RAND__();
			});

			if(!$j("#item-container__RAND__").length){
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_item__RAND__.value, t: 'transactions', f: 'item' },
					success: function(resp){
						$j('[name="item"]').val(resp.results[0].id);
						$j('[id=item-container-readonly__RAND__]').html('<span id="item-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=items_view_parent]').hide(); }else{ $j('.btn[id=items_view_parent]').show(); }

						if(typeof(item_update_autofills__RAND__) == 'function') item_update_autofills__RAND__();
					}
				});
			}

		<?php }else{ ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_item__RAND__.value, t: 'transactions', f: 'item' },
				success: function(resp){
					$j('[id=item-container__RAND__], [id=item-container-readonly__RAND__]').html('<span id="item-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=items_view_parent]').hide(); }else{ $j('.btn[id=items_view_parent]').show(); }

					if(typeof(item_update_autofills__RAND__) == 'function') item_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
		function batch_reload__RAND__(filterer_item){
		<?php if(($AllowUpdate || $AllowInsert) && !$dvprint){ ?>

			$j("#batch-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c){
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { filterer_item: filterer_item, id: AppGini.current_batch__RAND__.value, t: 'transactions', f: 'batch' },
						success: function(resp){
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="batch"]').val(resp.results[0].id);
							$j('[id=batch-container-readonly__RAND__]').html('<span id="batch-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=batches_view_parent]').hide(); }else{ $j('.btn[id=batches_view_parent]').show(); }


							if(typeof(batch_update_autofills__RAND__) == 'function') batch_update_autofills__RAND__();
						}
					});
				},
				width: ($j('fieldset .col-xs-11').width() - select2_max_width_decrement()) + 'px',
				formatNoMatches: function(term){ return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 10,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page){ return { filterer_item: filterer_item, s: term, p: page, t: 'transactions', f: 'batch' }; },
					results: function(resp, page){ return resp; }
				},
				escapeMarkup: function(str){ return str; }
			}).on('change', function(e){
				AppGini.current_batch__RAND__.value = e.added.id;
				AppGini.current_batch__RAND__.text = e.added.text;
				$j('[name="batch"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=batches_view_parent]').hide(); }else{ $j('.btn[id=batches_view_parent]').show(); }


				if(typeof(batch_update_autofills__RAND__) == 'function') batch_update_autofills__RAND__();
			});

			if(!$j("#batch-container__RAND__").length){
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_batch__RAND__.value, t: 'transactions', f: 'batch' },
					success: function(resp){
						$j('[name="batch"]').val(resp.results[0].id);
						$j('[id=batch-container-readonly__RAND__]').html('<span id="batch-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=batches_view_parent]').hide(); }else{ $j('.btn[id=batches_view_parent]').show(); }

						if(typeof(batch_update_autofills__RAND__) == 'function') batch_update_autofills__RAND__();
					}
				});
			}

		<?php }else{ ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_batch__RAND__.value, t: 'transactions', f: 'batch' },
				success: function(resp){
					$j('[id=batch-container__RAND__], [id=batch-container-readonly__RAND__]').html('<span id="batch-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=batches_view_parent]').hide(); }else{ $j('.btn[id=batches_view_parent]').show(); }

					if(typeof(batch_update_autofills__RAND__) == 'function') batch_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
		function section_reload__RAND__(){
		<?php if(($AllowUpdate || $AllowInsert) && !$dvprint){ ?>

			$j("#section-container__RAND__").select2({
				/* initial default value */
				initSelection: function(e, c){
					$j.ajax({
						url: 'ajax_combo.php',
						dataType: 'json',
						data: { id: AppGini.current_section__RAND__.value, t: 'transactions', f: 'section' },
						success: function(resp){
							c({
								id: resp.results[0].id,
								text: resp.results[0].text
							});
							$j('[name="section"]').val(resp.results[0].id);
							$j('[id=section-container-readonly__RAND__]').html('<span id="section-match-text">' + resp.results[0].text + '</span>');
							if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=sections_view_parent]').hide(); }else{ $j('.btn[id=sections_view_parent]').show(); }


							if(typeof(section_update_autofills__RAND__) == 'function') section_update_autofills__RAND__();
						}
					});
				},
				width: ($j('fieldset .col-xs-11').width() - select2_max_width_decrement()) + 'px',
				formatNoMatches: function(term){ return '<?php echo addslashes($Translation['No matches found!']); ?>'; },
				minimumResultsForSearch: 10,
				loadMorePadding: 200,
				ajax: {
					url: 'ajax_combo.php',
					dataType: 'json',
					cache: true,
					data: function(term, page){ return { s: term, p: page, t: 'transactions', f: 'section' }; },
					results: function(resp, page){ return resp; }
				},
				escapeMarkup: function(str){ return str; }
			}).on('change', function(e){
				AppGini.current_section__RAND__.value = e.added.id;
				AppGini.current_section__RAND__.text = e.added.text;
				$j('[name="section"]').val(e.added.id);
				if(e.added.id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=sections_view_parent]').hide(); }else{ $j('.btn[id=sections_view_parent]').show(); }


				if(typeof(section_update_autofills__RAND__) == 'function') section_update_autofills__RAND__();
			});

			if(!$j("#section-container__RAND__").length){
				$j.ajax({
					url: 'ajax_combo.php',
					dataType: 'json',
					data: { id: AppGini.current_section__RAND__.value, t: 'transactions', f: 'section' },
					success: function(resp){
						$j('[name="section"]').val(resp.results[0].id);
						$j('[id=section-container-readonly__RAND__]').html('<span id="section-match-text">' + resp.results[0].text + '</span>');
						if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=sections_view_parent]').hide(); }else{ $j('.btn[id=sections_view_parent]').show(); }

						if(typeof(section_update_autofills__RAND__) == 'function') section_update_autofills__RAND__();
					}
				});
			}

		<?php }else{ ?>

			$j.ajax({
				url: 'ajax_combo.php',
				dataType: 'json',
				data: { id: AppGini.current_section__RAND__.value, t: 'transactions', f: 'section' },
				success: function(resp){
					$j('[id=section-container__RAND__], [id=section-container-readonly__RAND__]').html('<span id="section-match-text">' + resp.results[0].text + '</span>');
					if(resp.results[0].id == '<?php echo empty_lookup_value; ?>'){ $j('.btn[id=sections_view_parent]').hide(); }else{ $j('.btn[id=sections_view_parent]').show(); }

					if(typeof(section_update_autofills__RAND__) == 'function') section_update_autofills__RAND__();
				}
			});
		<?php } ?>

		}
	</script>
	<?php

	$lookups = str_replace('__RAND__', $rnd1, ob_get_contents());
	ob_end_clean();


	// code for template based detail view forms

	// open the detail view template
	if($dvprint){
		$template_file = is_file("./{$TemplateDVP}") ? "./{$TemplateDVP}" : './templates/transactions_templateDVP.html';
		$templateCode = @file_get_contents($template_file);
	}else{
		$template_file = is_file("./{$TemplateDV}") ? "./{$TemplateDV}" : './templates/transactions_templateDV.html';
		$templateCode = @file_get_contents($template_file);
	}

	// process form title
	$templateCode = str_replace('<%%DETAIL_VIEW_TITLE%%>', 'Transaction details', $templateCode);
	$templateCode = str_replace('<%%RND1%%>', $rnd1, $templateCode);
	$templateCode = str_replace('<%%EMBEDDED%%>', ($_REQUEST['Embedded'] ? 'Embedded=1' : ''), $templateCode);
	// process buttons
	if($AllowInsert){
		if(!$selected_id) $templateCode=str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-success" id="insert" name="insert_x" value="1" onclick="return transactions_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save New'] . '</button>', $templateCode);
		$templateCode=str_replace('<%%INSERT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="insert" name="insert_x" value="1" onclick="return transactions_validateData();"><i class="glyphicon glyphicon-plus-sign"></i> ' . $Translation['Save As Copy'] . '</button>', $templateCode);
	}else{
		$templateCode=str_replace('<%%INSERT_BUTTON%%>', '', $templateCode);
	}

	// 'Back' button action
	if($_REQUEST['Embedded']){
		$backAction = 'window.parent.jQuery(\'.modal\').modal(\'hide\'); return false;';
	}else{
		$backAction = '$$(\'form\')[0].writeAttribute(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;';
	}

	if($selected_id){
		if(!$_REQUEST['Embedded']) $templateCode=str_replace('<%%DVPRINT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="dvprint" name="dvprint_x" value="1" onclick="$$(\'form\')[0].writeAttribute(\'novalidate\', \'novalidate\'); document.myform.reset(); return true;" title="' . html_attr($Translation['Print Preview']) . '"><i class="glyphicon glyphicon-print"></i> ' . $Translation['Print Preview'] . '</button>', $templateCode);
		if($AllowUpdate){
			$templateCode=str_replace('<%%UPDATE_BUTTON%%>', '<button type="submit" class="btn btn-success btn-lg" id="update" name="update_x" value="1" onclick="return transactions_validateData();" title="' . html_attr($Translation['Save Changes']) . '"><i class="glyphicon glyphicon-ok"></i> ' . $Translation['Save Changes'] . '</button>', $templateCode);
		}else{
			$templateCode=str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		}
		if(($arrPerm[4]==1 && $ownerMemberID==getLoggedMemberID()) || ($arrPerm[4]==2 && $ownerGroupID==getLoggedGroupID()) || $arrPerm[4]==3){ // allow delete?
			$templateCode=str_replace('<%%DELETE_BUTTON%%>', '<button type="submit" class="btn btn-danger" id="delete" name="delete_x" value="1" onclick="return confirm(\'' . $Translation['are you sure?'] . '\');" title="' . html_attr($Translation['Delete']) . '"><i class="glyphicon glyphicon-trash"></i> ' . $Translation['Delete'] . '</button>', $templateCode);
		}else{
			$templateCode=str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		}
		$templateCode=str_replace('<%%DESELECT_BUTTON%%>', '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>', $templateCode);
	}else{
		$templateCode=str_replace('<%%UPDATE_BUTTON%%>', '', $templateCode);
		$templateCode=str_replace('<%%DELETE_BUTTON%%>', '', $templateCode);
		$templateCode=str_replace('<%%DESELECT_BUTTON%%>', ($ShowCancel ? '<button type="submit" class="btn btn-default" id="deselect" name="deselect_x" value="1" onclick="' . $backAction . '" title="' . html_attr($Translation['Back']) . '"><i class="glyphicon glyphicon-chevron-left"></i> ' . $Translation['Back'] . '</button>' : ''), $templateCode);
	}

	// set records to read only if user can't insert new records and can't edit current record
	if(($selected_id && !$AllowUpdate && !$AllowInsert) || (!$selected_id && !$AllowInsert)){
		$jsReadOnly .= "\tjQuery('#transaction_date').prop('readonly', true);\n";
		$jsReadOnly .= "\tjQuery('#transaction_dateDay, #transaction_dateMonth, #transaction_dateYear').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#item').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#item_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('#batch').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#batch_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('#section').prop('disabled', true).css({ color: '#555', backgroundColor: '#fff' });\n";
		$jsReadOnly .= "\tjQuery('#section_caption').prop('disabled', true).css({ color: '#555', backgroundColor: 'white' });\n";
		$jsReadOnly .= "\tjQuery('input[name=transaction_type]').parent().html('<div class=\"form-control-static\">' + jQuery('input[name=transaction_type]:checked').next().text() + '</div>')\n";
		$jsReadOnly .= "\tjQuery('#quantity').replaceWith('<div class=\"form-control-static\" id=\"quantity\">' + (jQuery('#quantity').val() || '') + '</div>');\n";
		$jsReadOnly .= "\tjQuery('.select2-container').hide();\n";

		$noUploads = true;
	}elseif($AllowInsert){
		$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', true);"; // temporarily disable form change handler
			$jsEditable .= "\tjQuery('form').eq(0).data('already_changed', false);"; // re-enable form change handler
	}

	// process combos
	$templateCode=str_replace('<%%COMBO(transaction_date)%%>', ($selected_id && !$arrPerm[3] ? '<div class="form-control-static">' . $combo_transaction_date->GetHTML(true) . '</div>' : $combo_transaction_date->GetHTML()), $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(transaction_date)%%>', $combo_transaction_date->GetHTML(true), $templateCode);
	$templateCode=str_replace('<%%COMBO(item)%%>', $combo_item->HTML, $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(item)%%>', $combo_item->MatchText, $templateCode);
	$templateCode=str_replace('<%%URLCOMBOTEXT(item)%%>', urlencode($combo_item->MatchText), $templateCode);
	$templateCode=str_replace('<%%COMBO(batch)%%>', $combo_batch->HTML, $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(batch)%%>', $combo_batch->MatchText, $templateCode);
	$templateCode=str_replace('<%%URLCOMBOTEXT(batch)%%>', urlencode($combo_batch->MatchText), $templateCode);
	$templateCode=str_replace('<%%COMBO(section)%%>', $combo_section->HTML, $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(section)%%>', $combo_section->MatchText, $templateCode);
	$templateCode=str_replace('<%%URLCOMBOTEXT(section)%%>', urlencode($combo_section->MatchText), $templateCode);
	$templateCode=str_replace('<%%COMBO(transaction_type)%%>', $combo_transaction_type->HTML, $templateCode);
	$templateCode=str_replace('<%%COMBOTEXT(transaction_type)%%>', $combo_transaction_type->SelectedData, $templateCode);

	/* lookup fields array: 'lookup field name' => array('parent table name', 'lookup field caption') */
	$lookup_fields = array(  'item' => array('items', 'Item'), 'batch' => array('batches', 'Batch'), 'section' => array('sections', 'Storage section'));
	foreach($lookup_fields as $luf => $ptfc){
		$pt_perm = getTablePermissions($ptfc[0]);

		// process foreign key links
		if($pt_perm['view'] || $pt_perm['edit']){
			$templateCode = str_replace("<%%PLINK({$luf})%%>", '<button type="button" class="btn btn-default view_parent hspacer-md" id="' . $ptfc[0] . '_view_parent" title="' . html_attr($Translation['View'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-eye-open"></i></button>', $templateCode);
		}

		// if user has insert permission to parent table of a lookup field, put an add new button
		if($pt_perm['insert'] && !$_REQUEST['Embedded']){
			$templateCode = str_replace("<%%ADDNEW({$ptfc[0]})%%>", '<button type="button" class="btn btn-success add_new_parent hspacer-md" id="' . $ptfc[0] . '_add_new" title="' . html_attr($Translation['Add New'] . ' ' . $ptfc[1]) . '"><i class="glyphicon glyphicon-plus-sign"></i></button>', $templateCode);
		}
	}

	// process images
	$templateCode=str_replace('<%%UPLOADFILE(id)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(transaction_date)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(item)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(batch)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(section)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(transaction_type)%%>', '', $templateCode);
	$templateCode=str_replace('<%%UPLOADFILE(quantity)%%>', '', $templateCode);

	// process values
	if($selected_id){
		$templateCode=str_replace('<%%VALUE(id)%%>', html_attr($row['id']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(id)%%>', urlencode($urow['id']), $templateCode);
		$templateCode=str_replace('<%%VALUE(transaction_date)%%>', @date('d/m/Y', @strtotime(html_attr($row['transaction_date']))), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(transaction_date)%%>', urlencode(@date('d/m/Y', @strtotime(html_attr($urow['transaction_date'])))), $templateCode);
		$templateCode=str_replace('<%%VALUE(item)%%>', html_attr($row['item']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(item)%%>', urlencode($urow['item']), $templateCode);
		$templateCode=str_replace('<%%VALUE(batch)%%>', html_attr($row['batch']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(batch)%%>', urlencode($urow['batch']), $templateCode);
		$templateCode=str_replace('<%%VALUE(section)%%>', html_attr($row['section']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(section)%%>', urlencode($urow['section']), $templateCode);
		$templateCode=str_replace('<%%VALUE(transaction_type)%%>', html_attr($row['transaction_type']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(transaction_type)%%>', urlencode($urow['transaction_type']), $templateCode);
		$templateCode=str_replace('<%%VALUE(quantity)%%>', html_attr($row['quantity']), $templateCode);
		$templateCode=str_replace('<%%URLVALUE(quantity)%%>', urlencode($urow['quantity']), $templateCode);
	}else{
		$templateCode=str_replace('<%%VALUE(id)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(id)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(transaction_date)%%>', '1', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(transaction_date)%%>', urlencode('1'), $templateCode);
		$templateCode=str_replace('<%%VALUE(item)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(item)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(batch)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(batch)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(section)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(section)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(transaction_type)%%>', '', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(transaction_type)%%>', urlencode(''), $templateCode);
		$templateCode=str_replace('<%%VALUE(quantity)%%>', '1.00', $templateCode);
		$templateCode=str_replace('<%%URLVALUE(quantity)%%>', urlencode('1.00'), $templateCode);
	}

	// process translations
	foreach($Translation as $symbol=>$trans){
		$templateCode=str_replace("<%%TRANSLATION($symbol)%%>", $trans, $templateCode);
	}

	// clear scrap
	$templateCode=str_replace('<%%', '<!-- ', $templateCode);
	$templateCode=str_replace('%%>', ' -->', $templateCode);

	// hide links to inaccessible tables
	if($_REQUEST['dvprint_x'] == ''){
		$templateCode .= "\n\n<script>\$j(function(){\n";
		$arrTables = getTableList();
		foreach($arrTables as $name => $caption){
			$templateCode .= "\t\$j('#{$name}_link').removeClass('hidden');\n";
			$templateCode .= "\t\$j('#xs_{$name}_link').removeClass('hidden');\n";
		}

		$templateCode .= $jsReadOnly;
		$templateCode .= $jsEditable;

		if(!$selected_id){
		}

		$templateCode.="\n});</script>\n";
	}

	// ajaxed auto-fill fields
	$templateCode .= '<script>';
	$templateCode .= '$j(function() {';


	$templateCode.="});";
	$templateCode.="</script>";
	$templateCode .= $lookups;

	// handle enforced parent values for read-only lookup fields

	// don't include blank images in lightbox gallery
	$templateCode = preg_replace('/blank.gif" data-lightbox=".*?"/', 'blank.gif"', $templateCode);

	// don't display empty email links
	$templateCode=preg_replace('/<a .*?href="mailto:".*?<\/a>/', '', $templateCode);

	/* default field values */
	$rdata = $jdata = get_defaults('transactions');
	if($selected_id){
		$jdata = get_joined_record('transactions', $selected_id);
		$rdata = $row;
	}
	$cache_data = array(
		'rdata' => array_map('nl2br', array_map('addslashes', $rdata)),
		'jdata' => array_map('nl2br', array_map('addslashes', $jdata)),
	);
	$templateCode .= loadView('transactions-ajax-cache', $cache_data);

	// hook: transactions_dv
	if(function_exists('transactions_dv')){
		$args=array();
		transactions_dv(($selected_id ? $selected_id : FALSE), getMemberInfo(), $templateCode, $args);
	}

	return $templateCode;
}
?>